package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.TestSqlserverAaa;
import com.izouma.awesomeadmin.service.TestSqlserverAaaService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/testSqlserverAaa")
public class TestSqlserverAaaController {

    @Autowired
    private TestSqlserverAaaService testSqlserverAaaService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(TestSqlserverAaa record) {
        List<TestSqlserverAaa> pp = testSqlserverAaaService.getTestSqlserverAaaList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTestSqlserverAaa", method = RequestMethod.GET)
    @ResponseBody
    public Result getTestSqlserverAaa(@RequestParam(required = false, value = "id") String id) {
        TestSqlserverAaa data = testSqlserverAaaService.getTestSqlserverAaaById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(TestSqlserverAaa record) {
        TestSqlserverAaa data = testSqlserverAaaService.getTestSqlserverAaa(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, TestSqlserverAaa record) {
        Map<String, Object> result = new HashMap<>();

        List<TestSqlserverAaa> pp =testSqlserverAaaService.getTestSqlserverAaaByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(TestSqlserverAaa record) {
        boolean num = testSqlserverAaaService.createTestSqlserverAaa(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTestSqlserverAaa(TestSqlserverAaa record) {
        boolean num = testSqlserverAaaService.updateTestSqlserverAaa(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTestSqlserverAaa(@RequestParam(required = true, value = "id") String id) {

        boolean num = testSqlserverAaaService.deleteTestSqlserverAaa(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, TestSqlserverAaa record) throws Exception {

    List<TestSqlserverAaa> testSqlserverAaas = testSqlserverAaaService.getTestSqlserverAaaList(record);


        String sheetName = "test_sqlserver_aaa";
        String titleName = "测试sqlserver aaa数据表";
        String fileName = "测试sqlserver aaa表";
        int columnNumber = 4;
        int[] columnWidth = { 20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "测试" ,   "bbb"  };
        String[][] dataList = new String[testSqlserverAaas.size()][4];

        for (int i = 0; i < testSqlserverAaas.size(); i++) {

                        dataList[i][0] = String.valueOf(testSqlserverAaas.get(i).getId());
                        dataList[i][1] = String.valueOf(testSqlserverAaas.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(testSqlserverAaas.get(i).getNameAaa());
                        dataList[i][3] = String.valueOf(testSqlserverAaas.get(i).getNameBbb());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

